Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
CharacterJoint Class Reference

This represents one joint of the character's animation, containing an animating transform matrix. More...

`#include "characterJoint.h"`

Inheritance diagram for CharacterJoint:

## Public Member Functions
| CharacterJoint (Character *character, PartBundle *root, PartGroup *parent, const std::string &name, const LMatrix4 &default_value)
bool | add_local_transform (PandaNode *node)
| Adds the indicated node to the list of nodes that will be updated each frame with the joint's local transform from its parent. More...
bool | add_net_transform (PandaNode *node)
| Adds the indicated node to the list of nodes that will be updated each frame with the joint's net transform from the root. More...
void | clear_local_transforms ()
| Removes all nodes from the list of nodes that will be updated each frame with the joint's local transform from its parent. More...
void | clear_net_transforms ()
| Removes all nodes from the list of nodes that will be updated each frame with the joint's net transform from the root. More...
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Takes in a vector of pointers to TypedWritable objects that correspond to all the requests for pointers that this object made to BamReader. More...
| CPT (TransformState) get_transform_state() const
virtual void | do_xform (const LMatrix4 &mat, const LMatrix4 &inv_mat)
| Called by PartBundle::xform(), this indicates the indicated transform is being applied to the root joint. More...
virtual TypeHandle | force_init_type ()
Character * | get_character () const
NodePathCollection | get_local_transforms ()
| Returns a list of the local transforms set for this node. More...
void | get_net_transform (LMatrix4 &transform) const
NodePathCollection | get_net_transforms ()
| Returns a list of the net transforms set for this node. More...
const LMatrix4 & | get_transform () const
| Returns the transform matrix of the joint. More...
void | get_transform (LMatrix4 &transform) const
| Copies the joint's current transform into the indicated matrix. More...
virtual TypeHandle | get_type () const
bool | has_local_transform (PandaNode *node) const
| Returns true if the node is on the list of nodes that will be updated each frame with the joint's local transform from its parent, false otherwise. More...
bool | has_net_transform (PandaNode *node) const
| Returns true if the node is on the list of nodes that will be updated each frame with the joint's net transform from the root, false otherwise. More...
virtual bool | is_character_joint () const
| Returns true if this part is a CharacterJoint, false otherwise. More...
virtual PartGroup * | make_copy () const
| Allocates and returns a new copy of the node. More...
| PT (PandaNode) _geom_node
bool | remove_local_transform (PandaNode *node)
| Removes the indicated node from the list of nodes that will be updated each frame with the joint's local transform from its parent. More...
bool | remove_net_transform (PandaNode *node)
| Removes the indicated node from the list of nodes that will be updated each frame with the joint's net transform from the root. More...
virtual bool | update_internals (PartBundle *root, PartGroup *parent, bool self_changed, bool parent_changed, Thread *current_thread)
| This is called by do_update() whenever the part or some ancestor has changed values. More...
virtual void | write_datagram (BamWriter *manager, Datagram &me)
| Function to write the important information in the particular object to a Datagram. More...
Public Member Functions inherited from MovingPartMatrix
| MovingPartMatrix (PartGroup *parent, const std::string &name, const LMatrix4 &default_value)
virtual bool | apply_control (PandaNode *node)
| Specifies a node to influence this particular joint so that it will always hold the node's transform. More...
virtual bool | apply_freeze_matrix (const LVecBase3 &pos, const LVecBase3 &hpr, const LVecBase3 &scale)
| Freezes this particular joint so that it will always hold the specified transform. More...
virtual void | get_blend_value (const PartBundle *root)
| Attempts to blend the various matrix values indicated, and sets the _value member to the resulting matrix. More...
virtual AnimChannelBase * | make_default_channel () const
| Creates and returns a new AnimChannel that is not part of any hierarchy, but that returns the default value associated with this part. More...
Public Member Functions inherited from MovingPart< ACMatrixSwitchType >
| MovingPart (PartGroup *parent, const std::string &name, const ValueType &default_value)
ValueType | get_default_value () const
ValueType | get_value () const
virtual TypeHandle | get_value_type () const
| Returns the TypeHandle associated with the ValueType we are concerned with. More...
virtual void | output_value (std::ostream &out) const
| Outputs a very brief description of the channel's current value. More...
Public Member Functions inherited from MovingPartBase
| MovingPartBase (PartGroup *parent, const std::string &name)
virtual bool | clear_forced_channel ()
| Undoes the effect of a previous call to apply_freeze() or apply_control(). More...
virtual bool | do_update (PartBundle *root, const CycleData *root_cdata, PartGroup *parent, bool parent_changed, bool anim_changed, Thread *current_thread)
| Recursively update this particular part and all of its descendents for the current frame. More...
AnimChannelBase * | get_bound (int n) const
| Returns the nth bound channel on this PartGroup. More...
virtual AnimChannelBase * | get_forced_channel () const
| Returns the AnimChannelBase that has been forced to this joint by a previous call to apply_freeze() or apply_control(), or NULL if no such channel has been applied. More...
int | get_max_bound () const
| Returns the number of channels that might be bound to this PartGroup. More...
virtual void | write (std::ostream &out, int indent_level) const
| Writes a brief description of the channel and all of its descendants. More...
virtual void | write_with_value (std::ostream &out, int indent_level) const
| Writes a brief description of the channel and all of its descendants, along with their values. More...
Public Member Functions inherited from PartGroup
| PartGroup (PartGroup *parent, const std::string &name)
| Creates the PartGroup, and adds it to the indicated parent. More...
bool | apply_freeze (const TransformState *transform)
| Freezes this particular joint so that it will always hold the specified transform. More...
virtual bool | apply_freeze_scalar (PN_stdfloat value)
| Freezes this particular joint so that it will always hold the specified transform. More...
bool | check_hierarchy (const AnimGroup *anim, const PartGroup *parent, int hierarchy_match_flags=0) const
| Walks the part hierarchy in tandem with the indicated anim hierarchy, and returns true if the hierarchies match, false otherwise. More...
PartGroup * | copy_subgraph () const
| Allocates and returns a new copy of this node and of all of its children. More...
PartGroup * | find_child (const std::string &name) const
| Returns the first descendant found with the indicated name, or NULL if no such descendant exists. More...
PartGroup * | get_child (int n) const
PartGroup * | get_child_named (const std::string &name) const
| Returns the first child found with the indicated name, or NULL if no such child exists. More...
int | get_num_children () const
void | sort_descendants ()
| Sorts the children nodes at each level of the hierarchy into alphabetical order. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty. More...
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty. More...
void | output (std::ostream &out) const
| Outputs the Namable. More...
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_CharacterJoint (const FactoryParams &params)
| Factory method to generate a CharacterJoint object. More...
static void | register_with_read_factory ()
| Factory method to generate a CharacterJoint object. More...
Static Public Member Functions inherited from MovingPartMatrix
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_MovingPartMatrix (const FactoryParams &params)
| Factory method to generate a MovingPartMatrix object. More...
static void | register_with_read_factory ()
| Factory method to generate a MovingPartMatrix object. More...
Static Public Member Functions inherited from MovingPart< ACMatrixSwitchType >
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from MovingPartBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PartGroup
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_PartGroup (const FactoryParams &params)
| Factory method to generate a PartGroup object. More...
static void | register_with_read_factory ()
| Factory method to generate a PartGroup object. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
LMatrix4 | _initial_net_transform_inverse
LMatrix4 | _net_transform
LMatrix4 | _skinning_matrix
Public Attributes inherited from MovingPart< ACMatrixSwitchType >
ValueType | _default_value
ValueType | _value
Public Attributes inherited from PartGroup
| get_child
| Returns the nth child of the group. More...
| get_num_children
| Returns the number of child nodes of the group. More...
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...
Public Attributes inherited from Namable
| get_name
| set_name

## Friends
class | Character
class | CharacterJointBundle
class | JointVertexTransform

## Additional Inherited Members
Public Types inherited from MovingPart< ACMatrixSwitchType >
typedef AnimChannel< ACMatrixSwitchType > | ChannelType
typedef SwitchType::ValueType | ValueType
Public Types inherited from PartGroup
enum | HierarchyMatchFlags { HMF_ok_part_extra = 0x01 , HMF_ok_anim_extra = 0x02 , HMF_ok_wrong_root_name = 0x04 }
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This represents one joint of the character's animation, containing an animating transform matrix.

Definition at line 32 of file characterJoint.h.

## Member Function Documentation

## ◆ add_local_transform()

bool CharacterJoint::add_local_transform | ( | PandaNode * | node | ) |

Adds the indicated node to the list of nodes that will be updated each frame with the joint's local transform from its parent.

Returns true if the node is successfully added, false if it had already been added.

The Character pointer should be the Character object that owns this joint; this will be used to create a CharacterJointEffect for this node. If it is NULL, no such effect will be created.

A CharacterJointEffect for this joint's Character will automatically be added to the specified node.

Definition at line 287 of file characterJoint.cxx.

References Thread::get_current_thread, PandaNode::set_effect(), and PandaNode::set_transform.

## ◆ add_net_transform()

bool CharacterJoint::add_net_transform | ( | PandaNode * | node | ) |

Adds the indicated node to the list of nodes that will be updated each frame with the joint's net transform from the root.

Returns true if the node is successfully added, false if it had already been added.

A CharacterJointEffect for this joint's Character will automatically be added to the specified node.

Definition at line 195 of file characterJoint.cxx.

References Thread::get_current_thread, PandaNode::set_effect(), and PandaNode::set_transform.

## ◆ clear_local_transforms()

void CharacterJoint::clear_local_transforms | ( |  | ) |

Removes all nodes from the list of nodes that will be updated each frame with the joint's local transform from its parent.

Definition at line 329 of file characterJoint.cxx.

References ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ clear_net_transforms()

void CharacterJoint::clear_net_transforms | ( |  | ) |

Removes all nodes from the list of nodes that will be updated each frame with the joint's net transform from the root.

Definition at line 237 of file characterJoint.cxx.

References ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ complete_pointers()

int CharacterJoint::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager
| ) |  |
| virtual

Takes in a vector of pointers to TypedWritable objects that correspond to all the requests for pointers that this object made to BamReader.

Reimplemented from MovingPartBase.

Definition at line 510 of file characterJoint.cxx.

## ◆ do_xform()

void CharacterJoint::do_xform | ( | const LMatrix4 & | mat,
|  | const LMatrix4 & | inv_mat
| ) |  |
| virtual

Called by PartBundle::xform(), this indicates the indicated transform is being applied to the root joint.

Reimplemented from PartGroup.

Definition at line 178 of file characterJoint.cxx.

## ◆ get_local_transforms()

NodePathCollection CharacterJoint::get_local_transforms | ( |  | ) |

Returns a list of the local transforms set for this node.

Note that this returns a list of NodePaths, even though the local transforms are actually a list of PandaNodes.

Definition at line 352 of file characterJoint.cxx.

References NodePathCollection::add_path(), NodePath::any_path(), ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ get_net_transforms()

NodePathCollection CharacterJoint::get_net_transforms | ( |  | ) |

Returns a list of the net transforms set for this node.

Note that this returns a list of NodePaths, even though the net transforms are actually a list of PandaNodes.

Definition at line 260 of file characterJoint.cxx.

References NodePathCollection::add_path(), NodePath::any_path(), ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ get_transform() [1/2]

const LMatrix4 & CharacterJoint::get_transform | ( |  | ) | const
| inline

Returns the transform matrix of the joint.

Definition at line 17 of file characterJoint.I.

## ◆ get_transform() [2/2]

void CharacterJoint::get_transform | ( | LMatrix4 & | transform | ) | const

Copies the joint's current transform into the indicated matrix.

Definition at line 370 of file characterJoint.cxx.

## ◆ has_local_transform()

bool CharacterJoint::has_local_transform | ( | PandaNode * | node | ) | const

Returns true if the node is on the list of nodes that will be updated each frame with the joint's local transform from its parent, false otherwise.

Definition at line 320 of file characterJoint.cxx.

References ordered_vector< Key, Compare, Vector >::count().

## ◆ has_net_transform()

bool CharacterJoint::has_net_transform | ( | PandaNode * | node | ) | const

Returns true if the node is on the list of nodes that will be updated each frame with the joint's net transform from the root, false otherwise.

Definition at line 228 of file characterJoint.cxx.

References ordered_vector< Key, Compare, Vector >::count().

## ◆ is_character_joint()

bool CharacterJoint::is_character_joint | ( |  | ) | const
| virtual

Returns true if this part is a CharacterJoint, false otherwise.

This is a tiny optimization over is_of_type(CharacterType::get_class_type()).

Reimplemented from PartGroup.

Definition at line 85 of file characterJoint.cxx.

## ◆ make_CharacterJoint()

TypedWritable * CharacterJoint::make_CharacterJoint | ( | const FactoryParams & | params | ) |
| static

Factory method to generate a CharacterJoint object.

Definition at line 537 of file characterJoint.cxx.

References parse_params().

Referenced by register_with_read_factory().

## ◆ make_copy()

PartGroup * CharacterJoint::make_copy | ( |  | ) | const
| virtual

Allocates and returns a new copy of the node.

Children are not copied, but see copy_subgraph().

Reimplemented from PartGroup.

Definition at line 94 of file characterJoint.cxx.

## ◆ register_with_read_factory()

void CharacterJoint::register_with_read_factory | ( |  | ) |
| static

Factory method to generate a CharacterJoint object.

Definition at line 551 of file characterJoint.cxx.

References BamReader::get_factory(), make_CharacterJoint(), and Factory< Type >::register_factory().

Referenced by init_libchar().

## ◆ remove_local_transform()

bool CharacterJoint::remove_local_transform | ( | PandaNode * | node | ) |

Removes the indicated node from the list of nodes that will be updated each frame with the joint's local transform from its parent.

Returns true if the node is successfully removed, false if it was not on the list.

If the node has a CharacterJointEffect that matches this joint's Character, it will be cleared.

Definition at line 305 of file characterJoint.cxx.

## ◆ remove_net_transform()

bool CharacterJoint::remove_net_transform | ( | PandaNode * | node | ) |

Removes the indicated node from the list of nodes that will be updated each frame with the joint's net transform from the root.

Returns true if the node is successfully removed, false if it was not on the list.

If the node has a CharacterJointEffect that matches this joint's Character, it will be cleared.

Definition at line 213 of file characterJoint.cxx.

## ◆ update_internals()

bool CharacterJoint::update_internals | ( | PartBundle * | root,
|  | PartGroup * | parent,
|  | bool | self_changed,
|  | bool | parent_changed,
|  | Thread * | current_thread
| ) |  |
| virtual

This is called by do_update() whenever the part or some ancestor has changed values.

It is a hook for derived classes to update whatever cache they may have that depends on these.

The return value is true if the part has changed as a result of the update, or false otherwise.

In the case of a CharacterJoint, of course, it means to recompute the joint angles and associated transforms for this particular joint.

Reimplemented from MovingPartBase.

Definition at line 110 of file characterJoint.cxx.

## ◆ write_datagram()

void CharacterJoint::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | me
| ) |  |
| virtual

Function to write the important information in the particular object to a Datagram.

Reimplemented from MovingPart< ACMatrixSwitchType >.

Definition at line 455 of file characterJoint.cxx.

References Datagram::add_uint16(), ordered_vector< Key, Compare, Vector >::begin(), ordered_vector< Key, Compare, Vector >::end(), ordered_vector< Key, Compare, Vector >::size(), MovingPart< ACMatrixSwitchType >::write_datagram(), and BamWriter::write_pointer().

The documentation for this class was generated from the following files:

- panda/src/char/characterJoint.h
- panda/src/char/characterJoint.cxx
- panda/src/char/characterJoint.I